#include <iostream>
#include <algorithm>

using namespace std;

int main()
{
    int t;
    scanf("%d", &t);
    int n, k;
    scanf("%d %d", &n, &k);
    int l[n];
    for (int i=0; i<n; i++) scanf("%d", &l[i]);
    sort(l, l+n);

    // sim
    int a=0;
    int sgn[n];
    for (int i=0; i<n; i++) {
        if (a > l[i]) {
            a--;
            sgn[i] = -1;
        } else {
            a++;
            sgn[i] = 1;
        }
    }

    if (a < k) printf("NE");
    else {
        if (a == k) {
            printf("DA\n");
            if (t == 1) {
                for (auto el : l)
                    printf("%d ", el);
            }
        }
        else {
            int r = a-k;
            int i;
            for (i=0; i<n; i++) {
                if (sgn[i] == 1) {
                    break;
                }
            }
            int l2[n];
            int l2i=0;
            if (i+2>=n) {
                printf("NE");
            } else {
                for (int j=i+(r/2); j<n; j++) {
                    l2[l2i++] = l[j];
                }
                for (int j=(i+(r/2))-1; j>=0; j--) {
                    l2[l2i++] = l[j];
                }
                a=0;
                for (int i=0; i<n; i++) {
                    if (a > l2[i]) {
                        a--;
                    } else {
                        a++;
                    }
                }
                if (a==k) {
                    printf("DA\n");
                    if (t) {
                        for (auto el : l2) {
                            printf("%d ", el);
                        }
                    }
                } else {
                    printf("NE");
                }
            }

        }

    }

    return 0;
}